<template>
  <button
    class="signIn-btn"
    :class="classes"
    :style="{backgroundColor: !disabled ? loading ? 'rgba(212, 212, 212, 0.3)' : backgroundColor : null, color: color}"
    @click="click">
    <div class="signIn-btn-inner">
      <CircleSpin v-show="loading"></CircleSpin>
      <span
        class="signIn-btn-text"
        v-show="!loading"><slot></slot></span>
      <slot name="img"></slot>
    </div>
  </button>
</template>

<script>
  import CircleSpin from '~/components/UI/SpinKit/Circle';

  export default {
    name: "Btn_sign",
    data() {
      return {}
    },
    props: {
      scatter: {
        type: Boolean,
        default: false
      },
      lynx: {
        type: Boolean,
        default: false
      },
      qr: {
        type: Boolean,
        default: false
      },
      transparent: {
        type: Boolean,
        default: false
      },
      disabled: {
        type: Boolean,
        default: false
      },
      big: {
        type: Boolean,
        default: false
      },
      small: {
        type: Boolean,
        default: false
      },
      loading: {
        type: Boolean,
        default: false
      },
      backgroundColor: String,
      color: String
    },
    components: {
      CircleSpin
    },
    computed: {
      classes() {
        const scatter = this.scatter ? 'signIn-btn-scatter' : '';
        const lynx = this.lynx ? 'signIn-btn-lynx' : '';
        const qr = this.qr ? 'signIn-btn-qr' : '';
        const disabled = this.disabled ? ' disabled' : '';
        const c = scatter + lynx + qr + disabled;
        if (c && !disabled) return c;
        const transparent = this.transparent ? 'signIn-btn-transparent' : '';
        const small = this.small ? ' signIn-btn-small' : '';
        const big = this.big ? ' signIn-btn-big' : '';
        return transparent || 'signIn-btn-default' + big + small + ' ' + disabled;
      }
    },
    methods: {
      click() {
        if (this.disabled || this.loading) return;
        this.$emit('click');
      }
    }
  }
</script>
